/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Dictionary.h"
#include "com_phidget22_DictionaryBase.h"

jclass dictionary_class;
extern jfieldID phidget_handle_fid;
jmethodID dictionary_cons;

static jclass addEvent_class;
static jmethodID fireAdd_mid	;
static jmethodID addEvent_cons;
static jfieldID nativeAddHandler_fid;

static jclass updateEvent_class;
static jmethodID fireUpdate_mid	;
static jmethodID updateEvent_cons;
static jfieldID nativeUpdateHandler_fid;

static jclass removeEvent_class;
static jmethodID fireRemove_mid	;
static jmethodID removeEvent_cons;
static jfieldID nativeRemoveHandler_fid;

void com_phidget22_DictionaryBase_OnLoad(JNIEnv *env) {
	if (!(dictionary_class = (*env)->FindClass(env, "com/phidget22/DictionaryBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryBase");
	if (!(dictionary_class = (jclass)(*env)->NewGlobalRef(env, dictionary_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef dictionary_class");
	if (!(dictionary_cons = (*env)->GetMethodID(env, dictionary_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from dictionary_class");

	if (!(addEvent_class = (*env)->FindClass(env, "com/phidget22/DictionaryAddEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryAddEvent");
	if (!(addEvent_class = (jclass)(*env)->NewGlobalRef(env, addEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref AddEvent_class");
	if (!(fireAdd_mid = (*env)->GetMethodID(env, dictionary_class, "fireAdd", "(Lcom/phidget22/DictionaryAddEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireAdd");
	if (!(addEvent_cons = (*env)->GetMethodID(env, addEvent_class, "<init>", "(Lcom/phidget22/Dictionary;Ljava/lang/String;Ljava/lang/String;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from AddEvent_class");
	if (!(nativeAddHandler_fid = (*env)->GetFieldID(env, dictionary_class, "nativeAddHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeAddHandler from dictionary_class");

	if (!(updateEvent_class = (*env)->FindClass(env, "com/phidget22/DictionaryUpdateEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryUpdateEvent");
	if (!(updateEvent_class = (jclass)(*env)->NewGlobalRef(env, updateEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref UpdateEvent_class");
	if (!(fireUpdate_mid = (*env)->GetMethodID(env, dictionary_class, "fireUpdate", "(Lcom/phidget22/DictionaryUpdateEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireUpdate");
	if (!(updateEvent_cons = (*env)->GetMethodID(env, updateEvent_class, "<init>", "(Lcom/phidget22/Dictionary;Ljava/lang/String;Ljava/lang/String;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from UpdateEvent_class");
	if (!(nativeUpdateHandler_fid = (*env)->GetFieldID(env, dictionary_class, "nativeUpdateHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeUpdateHandler from dictionary_class");

	if (!(removeEvent_class = (*env)->FindClass(env, "com/phidget22/DictionaryRemoveEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DictionaryRemoveEvent");
	if (!(removeEvent_class = (jclass)(*env)->NewGlobalRef(env, removeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref RemoveEvent_class");
	if (!(fireRemove_mid = (*env)->GetMethodID(env, dictionary_class, "fireRemove", "(Lcom/phidget22/DictionaryRemoveEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireRemove");
	if (!(removeEvent_cons = (*env)->GetMethodID(env, removeEvent_class, "<init>", "(Lcom/phidget22/Dictionary;Ljava/lang/String;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from RemoveEvent_class");
	if (!(nativeRemoveHandler_fid = (*env)->GetFieldID(env, dictionary_class, "nativeRemoveHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeRemoveHandler from dictionary_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DictionaryBase_create(JNIEnv * env, jclass obj) {
	PhidgetDictionaryHandle phid;
	int error; 
	if ((error = PhidgetDictionary_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_add(JNIEnv * env, jobject obj, jstring key, jstring value) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDictionary_add(h, (const char *)(key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL)), (const char *)(value == NULL ? NULL : (*env)->GetStringUTFChars(env, value, NULL)))))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_removeAll(JNIEnv * env, jobject obj) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDictionary_removeAll(h)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_remove(JNIEnv * env, jobject obj, jstring key) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDictionary_remove(h, (const char *)(key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL)))))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_set(JNIEnv * env, jobject obj, jstring key, jstring value) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDictionary_set(h, (const char *)(key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL)), (const char *)(value == NULL ? NULL : (*env)->GetStringUTFChars(env, value, NULL)))))
		PH_THROW(error);
}

JNIEXPORT jstring JNICALL Java_com_phidget22_DictionaryBase_sscan(JNIEnv * env, jobject obj, jstring start) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	char keyslist[65536];
	size_t len = 65536;
	if ((error = PhidgetDictionary_scan(h, (const char *)(start == NULL ? NULL : (*env)->GetStringUTFChars(env, start, NULL)), keyslist, (size_t)len)))
		PH_THROW(error);
	return (*env)->NewStringUTF(env, keyslist);
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_update(JNIEnv * env, jobject obj, jstring key, jstring value) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDictionary_update(h, (const char *)(key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL)), (const char *)(value == NULL ? NULL : (*env)->GetStringUTFChars(env, value, NULL)))))
		PH_THROW(error);
}

static void CCONV add_handler(PhidgetDictionaryHandle h, void *arg, const char * key, const char * value) {
	jobject addEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((addEv = (*env)->NewObject(env, addEvent_class, addEvent_cons, obj, (*env)->NewStringUTF(env, key), (*env)->NewStringUTF(env, value))) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAdd_mid, addEv);
		(*env)->DeleteLocalRef(env, addEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_enableAddEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeAddHandler_fid, b);
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDictionary_setOnAddHandler(h, b ? add_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV remove_handler(PhidgetDictionaryHandle h, void *arg, const char * key) {
	jobject removeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((removeEv = (*env)->NewObject(env, removeEvent_class, removeEvent_cons, obj, (*env)->NewStringUTF(env, key))) != 0) {
		(*env)->CallVoidMethod(env, obj, fireRemove_mid, removeEv);
		(*env)->DeleteLocalRef(env, removeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_enableRemoveEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeRemoveHandler_fid, b);
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDictionary_setOnRemoveHandler(h, b ? remove_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV update_handler(PhidgetDictionaryHandle h, void *arg, const char * key, const char * value) {
	jobject updateEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((updateEv = (*env)->NewObject(env, updateEvent_class, updateEvent_cons, obj, (*env)->NewStringUTF(env, key), (*env)->NewStringUTF(env, value))) != 0) {
		(*env)->CallVoidMethod(env, obj, fireUpdate_mid, updateEv);
		(*env)->DeleteLocalRef(env, updateEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DictionaryBase_enableUpdateEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeUpdateHandler_fid, b);
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDictionary_setOnUpdateHandler(h, b ? update_handler : NULL, (void *)(uintptr_t) gr);
}
