/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_DistanceSensor.h"
#include "com_phidget22_DistanceSensorBase.h"

jclass distanceSensor_class;
extern jfieldID phidget_handle_fid;
jmethodID distanceSensor_cons;

static jclass distanceChangeEvent_class;
static jmethodID fireDistanceChange_mid	;
static jmethodID distanceChangeEvent_cons;
static jfieldID nativeDistanceChangeHandler_fid;

static jclass sonarReflectionsUpdateEvent_class;
static jmethodID fireSonarReflectionsUpdate_mid	;
static jmethodID sonarReflectionsUpdateEvent_cons;
static jfieldID nativeSonarReflectionsUpdateHandler_fid;

void com_phidget22_DistanceSensorBase_OnLoad(JNIEnv *env) {
	if (!(distanceSensor_class = (*env)->FindClass(env, "com/phidget22/DistanceSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DistanceSensorBase");
	if (!(distanceSensor_class = (jclass)(*env)->NewGlobalRef(env, distanceSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef distanceSensor_class");
	if (!(distanceSensor_cons = (*env)->GetMethodID(env, distanceSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from distanceSensor_class");

	if (!(distanceChangeEvent_class = (*env)->FindClass(env, "com/phidget22/DistanceSensorDistanceChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DistanceSensorDistanceChangeEvent");
	if (!(distanceChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, distanceChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref DistanceChangeEvent_class");
	if (!(fireDistanceChange_mid = (*env)->GetMethodID(env, distanceSensor_class, "fireDistanceChange", "(Lcom/phidget22/DistanceSensorDistanceChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireDistanceChange");
	if (!(distanceChangeEvent_cons = (*env)->GetMethodID(env, distanceChangeEvent_class, "<init>", "(Lcom/phidget22/DistanceSensor;I)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from DistanceChangeEvent_class");
	if (!(nativeDistanceChangeHandler_fid = (*env)->GetFieldID(env, distanceSensor_class, "nativeDistanceChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeDistanceChangeHandler from distanceSensor_class");

	if (!(sonarReflectionsUpdateEvent_class = (*env)->FindClass(env, "com/phidget22/DistanceSensorSonarReflectionsUpdateEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/DistanceSensorSonarReflectionsUpdateEvent");
	if (!(sonarReflectionsUpdateEvent_class = (jclass)(*env)->NewGlobalRef(env, sonarReflectionsUpdateEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref SonarReflectionsUpdateEvent_class");
	if (!(fireSonarReflectionsUpdate_mid = (*env)->GetMethodID(env, distanceSensor_class, "fireSonarReflectionsUpdate", "(Lcom/phidget22/DistanceSensorSonarReflectionsUpdateEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireSonarReflectionsUpdate");
	if (!(sonarReflectionsUpdateEvent_cons = (*env)->GetMethodID(env, sonarReflectionsUpdateEvent_class, "<init>", "(Lcom/phidget22/DistanceSensor;[I[II)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from SonarReflectionsUpdateEvent_class");
	if (!(nativeSonarReflectionsUpdateHandler_fid = (*env)->GetFieldID(env, distanceSensor_class, "nativeSonarReflectionsUpdateHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeSonarReflectionsUpdateHandler from distanceSensor_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_DistanceSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetDistanceSensorHandle phid;
	int error; 
	if ((error = PhidgetDistanceSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetDistanceSensor_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_DistanceSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDistanceSensor_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetDistanceSensor_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetDistanceSensor_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getDistance(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t distance;
	if ((error = PhidgetDistanceSensor_getDistance(h, &distance)))
		PH_THROW(error);
	return distance;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getMinDistance(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDistance;
	if ((error = PhidgetDistanceSensor_getMinDistance(h, &minDistance)))
		PH_THROW(error);
	return minDistance;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getMaxDistance(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDistance;
	if ((error = PhidgetDistanceSensor_getMaxDistance(h, &maxDistance)))
		PH_THROW(error);
	return maxDistance;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getDistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t distanceChangeTrigger;
	if ((error = PhidgetDistanceSensor_getDistanceChangeTrigger(h, &distanceChangeTrigger)))
		PH_THROW(error);
	return distanceChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_DistanceSensorBase_setDistanceChangeTrigger(JNIEnv * env, jobject obj, jint distanceChangeTrigger) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDistanceSensor_setDistanceChangeTrigger(h, (uint32_t)distanceChangeTrigger)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getMinDistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDistanceChangeTrigger;
	if ((error = PhidgetDistanceSensor_getMinDistanceChangeTrigger(h, &minDistanceChangeTrigger)))
		PH_THROW(error);
	return minDistanceChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_DistanceSensorBase_getMaxDistanceChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDistanceChangeTrigger;
	if ((error = PhidgetDistanceSensor_getMaxDistanceChangeTrigger(h, &maxDistanceChangeTrigger)))
		PH_THROW(error);
	return maxDistanceChangeTrigger;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_DistanceSensorBase_getSonarQuietMode(JNIEnv * env, jobject obj) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int sonarQuietMode;
	if ((error = PhidgetDistanceSensor_getSonarQuietMode(h, &sonarQuietMode)))
		PH_THROW(error);
	return sonarQuietMode;
}

JNIEXPORT void JNICALL Java_com_phidget22_DistanceSensorBase_setSonarQuietMode(JNIEnv * env, jobject obj, jboolean sonarQuietMode) {
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetDistanceSensor_setSonarQuietMode(h, (int)sonarQuietMode)))
		PH_THROW(error);
}

static void CCONV distanceChange_handler(PhidgetDistanceSensorHandle h, void *arg, uint32_t distance) {
	jobject distanceChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((distanceChangeEv = (*env)->NewObject(env, distanceChangeEvent_class, distanceChangeEvent_cons, obj, distance)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireDistanceChange_mid, distanceChangeEv);
		(*env)->DeleteLocalRef(env, distanceChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DistanceSensorBase_enableDistanceChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeDistanceChangeHandler_fid, b);
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDistanceSensor_setOnDistanceChangeHandler(h, b ? distanceChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV sonarReflectionsUpdate_handler(PhidgetDistanceSensorHandle h, void *arg, const uint32_t distances[8], const uint32_t amplitudes[8], uint32_t count) {
	jobject sonarReflectionsUpdateEv;
	JNIEnv *env;
	jobject obj;
	jintArray distancesArr;
	jintArray amplitudesArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	distancesArr = (*env)->NewIntArray(env, (jsize)8);
	(*env)->SetIntArrayRegion(env, distancesArr, 0, (jsize)8, distances);
	amplitudesArr = (*env)->NewIntArray(env, (jsize)8);
	(*env)->SetIntArrayRegion(env, amplitudesArr, 0, (jsize)8, amplitudes);

	if ((sonarReflectionsUpdateEv = (*env)->NewObject(env, sonarReflectionsUpdateEvent_class, sonarReflectionsUpdateEvent_cons, obj, distancesArr, amplitudesArr, count)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireSonarReflectionsUpdate_mid, sonarReflectionsUpdateEv);
		(*env)->DeleteLocalRef(env, sonarReflectionsUpdateEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_DistanceSensorBase_enableSonarReflectionsUpdateEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeSonarReflectionsUpdateHandler_fid, b);
	PhidgetDistanceSensorHandle h = (PhidgetDistanceSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetDistanceSensor_setOnSonarReflectionsUpdateHandler(h, b ? sonarReflectionsUpdate_handler : NULL, (void *)(uintptr_t) gr);
}
