/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_IR.h"
#include "com_phidget22_IRBase.h"

jclass IR_class;
extern jfieldID phidget_handle_fid;
jmethodID IR_cons;

static jclass codeEvent_class;
static jmethodID fireCode_mid	;
static jmethodID codeEvent_cons;
static jfieldID nativeCodeHandler_fid;

static jclass learnEvent_class;
static jmethodID fireLearn_mid	;
static jmethodID learnEvent_cons;
static jfieldID nativeLearnHandler_fid;

static jclass rawDataEvent_class;
static jmethodID fireRawData_mid	;
static jmethodID rawDataEvent_cons;
static jfieldID nativeRawDataHandler_fid;

void com_phidget22_IRBase_OnLoad(JNIEnv *env) {
	if (!(IR_class = (*env)->FindClass(env, "com/phidget22/IRBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRBase");
	if (!(IR_class = (jclass)(*env)->NewGlobalRef(env, IR_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef IR_class");
	if (!(IR_cons = (*env)->GetMethodID(env, IR_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from IR_class");

	if (!(codeEvent_class = (*env)->FindClass(env, "com/phidget22/IRCodeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRCodeEvent");
	if (!(codeEvent_class = (jclass)(*env)->NewGlobalRef(env, codeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref CodeEvent_class");
	if (!(fireCode_mid = (*env)->GetMethodID(env, IR_class, "fireCode", "(Lcom/phidget22/IRCodeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireCode");
	if (!(codeEvent_cons = (*env)->GetMethodID(env, codeEvent_class, "<init>", "(Lcom/phidget22/IR;Ljava/lang/String;IZ)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from CodeEvent_class");
	if (!(nativeCodeHandler_fid = (*env)->GetFieldID(env, IR_class, "nativeCodeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeCodeHandler from IR_class");

	if (!(learnEvent_class = (*env)->FindClass(env, "com/phidget22/IRLearnEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRLearnEvent");
	if (!(learnEvent_class = (jclass)(*env)->NewGlobalRef(env, learnEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref LearnEvent_class");
	if (!(fireLearn_mid = (*env)->GetMethodID(env, IR_class, "fireLearn", "(Lcom/phidget22/IRLearnEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireLearn");
	if (!(learnEvent_cons = (*env)->GetMethodID(env, learnEvent_class, "<init>", "(Lcom/phidget22/IR;Ljava/lang/String;Lcom/phidget22/IRCodeInfo;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from LearnEvent_class");
	if (!(nativeLearnHandler_fid = (*env)->GetFieldID(env, IR_class, "nativeLearnHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeLearnHandler from IR_class");

	if (!(rawDataEvent_class = (*env)->FindClass(env, "com/phidget22/IRRawDataEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/IRRawDataEvent");
	if (!(rawDataEvent_class = (jclass)(*env)->NewGlobalRef(env, rawDataEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref RawDataEvent_class");
	if (!(fireRawData_mid = (*env)->GetMethodID(env, IR_class, "fireRawData", "(Lcom/phidget22/IRRawDataEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireRawData");
	if (!(rawDataEvent_cons = (*env)->GetMethodID(env, rawDataEvent_class, "<init>", "(Lcom/phidget22/IR;[I)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from RawDataEvent_class");
	if (!(nativeRawDataHandler_fid = (*env)->GetFieldID(env, IR_class, "nativeRawDataHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeRawDataHandler from IR_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_IRBase_create(JNIEnv * env, jclass obj) {
	PhidgetIRHandle phid;
	int error; 
	if ((error = PhidgetIR_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_transmit(JNIEnv * env, jobject obj, jstring code, jobject codeInfo) {
	PhidgetIRHandle h = (PhidgetIRHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	PhidgetIR_CodeInfo codeInfoVal = jobject_to_PhidgetIR_CodeInfo(env, codeInfo);
	if ((error = PhidgetIR_transmit(h, (const char *)(code == NULL ? NULL : (*env)->GetStringUTFChars(env, code, NULL)), &codeInfoVal)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_transmitRaw(JNIEnv * env, jobject obj, jintArray data, jint carrierFrequency, jdouble dutyCycle, jint gap) {
	PhidgetIRHandle h = (PhidgetIRHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t *dataArr = (*env)->GetIntArrayElements(env, data, 0);
	size_t dataLength = (*env)->GetArrayLength(env, data);
	if ((error = PhidgetIR_transmitRaw(h, dataArr, (size_t)dataLength, (uint32_t)carrierFrequency, (double)dutyCycle, (uint32_t)gap)))
		PH_THROW(error);
	(*env)->ReleaseIntArrayElements(env, data, dataArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_transmitRepeat(JNIEnv * env, jobject obj) {
	PhidgetIRHandle h = (PhidgetIRHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetIR_transmitRepeat(h)))
		PH_THROW(error);
}

static void CCONV code_handler(PhidgetIRHandle h, void *arg, const char * code, uint32_t bitCount, int isRepeat) {
	jobject codeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((codeEv = (*env)->NewObject(env, codeEvent_class, codeEvent_cons, obj, (*env)->NewStringUTF(env, code), bitCount, isRepeat)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireCode_mid, codeEv);
		(*env)->DeleteLocalRef(env, codeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_enableCodeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeCodeHandler_fid, b);
	PhidgetIRHandle h = (PhidgetIRHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetIR_setOnCodeHandler(h, b ? code_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV learn_handler(PhidgetIRHandle h, void *arg, const char * code, PhidgetIR_CodeInfo *codeInfo) {
	jobject learnEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((learnEv = (*env)->NewObject(env, learnEvent_class, learnEvent_cons, obj, (*env)->NewStringUTF(env, code), PhidgetIR_CodeInfo_to_jobject(env, codeInfo))) != 0) {
		(*env)->CallVoidMethod(env, obj, fireLearn_mid, learnEv);
		(*env)->DeleteLocalRef(env, learnEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_enableLearnEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeLearnHandler_fid, b);
	PhidgetIRHandle h = (PhidgetIRHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetIR_setOnLearnHandler(h, b ? learn_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV rawData_handler(PhidgetIRHandle h, void *arg, const uint32_t *data, size_t dataLength) {
	jobject rawDataEv;
	JNIEnv *env;
	jobject obj;
	jintArray dataArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	dataArr = (*env)->NewIntArray(env, (jsize)dataLength);
	(*env)->SetIntArrayRegion(env, dataArr, 0, (jsize)dataLength, data);

	if ((rawDataEv = (*env)->NewObject(env, rawDataEvent_class, rawDataEvent_cons, obj, dataArr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireRawData_mid, rawDataEv);
		(*env)->DeleteLocalRef(env, rawDataEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_IRBase_enableRawDataEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeRawDataHandler_fid, b);
	PhidgetIRHandle h = (PhidgetIRHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetIR_setOnRawDataHandler(h, b ? rawData_handler : NULL, (void *)(uintptr_t) gr);
}
