/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_LCD.h"
#include "com_phidget22_LCDBase.h"

jclass LCD_class;
extern jfieldID phidget_handle_fid;
jmethodID LCD_cons;

void com_phidget22_LCDBase_OnLoad(JNIEnv *env) {
	if (!(LCD_class = (*env)->FindClass(env, "com/phidget22/LCDBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/LCDBase");
	if (!(LCD_class = (jclass)(*env)->NewGlobalRef(env, LCD_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef LCD_class");
	if (!(LCD_cons = (*env)->GetMethodID(env, LCD_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from LCD_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_LCDBase_create(JNIEnv * env, jclass obj) {
	PhidgetLCDHandle phid;
	int error; 
	if ((error = PhidgetLCD_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getBacklight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double backlight;
	if ((error = PhidgetLCD_getBacklight(h, &backlight)))
		PH_THROW(error);
	return backlight;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setBacklight(JNIEnv * env, jobject obj, jdouble backlight) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setBacklight(h, (double)backlight)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMinBacklight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minBacklight;
	if ((error = PhidgetLCD_getMinBacklight(h, &minBacklight)))
		PH_THROW(error);
	return minBacklight;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMaxBacklight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxBacklight;
	if ((error = PhidgetLCD_getMaxBacklight(h, &maxBacklight)))
		PH_THROW(error);
	return maxBacklight;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCharacterBitmap__Lcom_phidget22_LCDFont_2Ljava_lang_String_2_3B(JNIEnv * env, jobject obj, jobject font, jstring character, jbyteArray bitmap) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	if ((error = PhidgetLCD_setCharacterBitmap(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (const char *)(character == NULL ? NULL : (*env)->GetStringUTFChars(env, character, NULL)), bitmapArr)))
		PH_THROW(error);
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCharacterBitmap__Lcom_phidget22_LCDFont_2Ljava_lang_String_2_3BLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject font, jstring character, jbyteArray bitmap, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_setCharacterBitmap_async(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (const char *)(character == NULL ? NULL : (*env)->GetStringUTFChars(env, character, NULL)), bitmapArr, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getMaxCharacters(JNIEnv * env, jobject obj, jobject font) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int maxCharacters;
	if ((error = PhidgetLCD_getMaxCharacters(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), &maxCharacters)))
		PH_THROW(error);
	return maxCharacters;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_clear__Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_clear_async(h, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_clear__(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_clear(h)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getContrast(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double contrast;
	if ((error = PhidgetLCD_getContrast(h, &contrast)))
		PH_THROW(error);
	return contrast;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setContrast(JNIEnv * env, jobject obj, jdouble contrast) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setContrast(h, (double)contrast)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMinContrast(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minContrast;
	if ((error = PhidgetLCD_getMinContrast(h, &minContrast)))
		PH_THROW(error);
	return minContrast;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_LCDBase_getMaxContrast(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxContrast;
	if ((error = PhidgetLCD_getMaxContrast(h, &maxContrast)))
		PH_THROW(error);
	return maxContrast;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_copy__IIIIIIIIZ(JNIEnv * env, jobject obj, jint srcFramebuffer, jint dstFramebuffer, jint srcX1, jint srcY1, jint srcX2, jint srcY2, jint dstX, jint dstY, jboolean inverted) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_copy(h, (int)srcFramebuffer, (int)dstFramebuffer, (int)srcX1, (int)srcY1, (int)srcX2, (int)srcY2, (int)dstX, (int)dstY, (int)inverted)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_copy__IIIIIIIIZLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint srcFramebuffer, jint dstFramebuffer, jint srcX1, jint srcY1, jint srcX2, jint srcY2, jint dstX, jint dstY, jboolean inverted, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_copy_async(h, (int)srcFramebuffer, (int)dstFramebuffer, (int)srcX1, (int)srcY1, (int)srcX2, (int)srcY2, (int)dstX, (int)dstY, (int)inverted, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LCDBase_getCursorBlink(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int cursorBlink;
	if ((error = PhidgetLCD_getCursorBlink(h, &cursorBlink)))
		PH_THROW(error);
	return cursorBlink;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCursorBlink(JNIEnv * env, jobject obj, jboolean cursorBlink) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setCursorBlink(h, (int)cursorBlink)))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LCDBase_getCursorOn(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int cursorOn;
	if ((error = PhidgetLCD_getCursorOn(h, &cursorOn)))
		PH_THROW(error);
	return cursorOn;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setCursorOn(JNIEnv * env, jobject obj, jboolean cursorOn) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setCursorOn(h, (int)cursorOn)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawLine__IIIILcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_drawLine_async(h, (int)x1, (int)y1, (int)x2, (int)y2, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawLine__IIII(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_drawLine(h, (int)x1, (int)y1, (int)x2, (int)y2)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawPixel__IILcom_phidget22_LCDPixelState_2(JNIEnv * env, jobject obj, jint x, jint y, jobject pixelState) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_drawPixel(h, (int)x, (int)y, (PhidgetLCD_PixelState)(*env)->CallIntMethod(env, pixelState, LCDPixelState_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawPixel__IILcom_phidget22_LCDPixelState_2Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint x, jint y, jobject pixelState, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_drawPixel_async(h, (int)x, (int)y, (PhidgetLCD_PixelState)(*env)->CallIntMethod(env, pixelState, LCDPixelState_getCode_mid), asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawRect__IIIIZZLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2, jboolean filled, jboolean inverted, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_drawRect_async(h, (int)x1, (int)y1, (int)x2, (int)y2, (int)filled, (int)inverted, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_drawRect__IIIIZZ(JNIEnv * env, jobject obj, jint x1, jint y1, jint x2, jint y2, jboolean filled, jboolean inverted) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_drawRect(h, (int)x1, (int)y1, (int)x2, (int)y2, (int)filled, (int)inverted)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_flush__(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_flush(h)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_flush__Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_flush_async(h, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setFontSize(JNIEnv * env, jobject obj, jobject font, jint width, jint height) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setFontSize(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (int)width, (int)height)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getFrameBuffer(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int frameBuffer;
	if ((error = PhidgetLCD_getFrameBuffer(h, &frameBuffer)))
		PH_THROW(error);
	return frameBuffer;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setFrameBuffer__I(JNIEnv * env, jobject obj, jint frameBuffer) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setFrameBuffer(h, (int)frameBuffer)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setFrameBuffer__ILcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint frameBuffer, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_setFrameBuffer_async(h, (int)frameBuffer, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getHeight(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int height;
	if ((error = PhidgetLCD_getHeight(h, &height)))
		PH_THROW(error);
	return height;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_initialize(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_initialize(h)))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_saveFrameBuffer__ILcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint frameBuffer, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_saveFrameBuffer_async(h, (int)frameBuffer, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_saveFrameBuffer__I(JNIEnv * env, jobject obj, jint frameBuffer) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_saveFrameBuffer(h, (int)frameBuffer)))
		PH_THROW(error);
}

JNIEXPORT jobject JNICALL Java_com_phidget22_LCDBase_getScreenSize(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	PhidgetLCD_ScreenSize screenSize;
	if ((error = PhidgetLCD_getScreenSize(h, &screenSize)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, LCDScreenSize_class, LCDScreenSize_getEnum_mid, screenSize);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setScreenSize(JNIEnv * env, jobject obj, jobject screenSize) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setScreenSize(h, (PhidgetLCD_ScreenSize)(*env)->CallIntMethod(env, screenSize, LCDScreenSize_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_LCDBase_getSleeping(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int sleeping;
	if ((error = PhidgetLCD_getSleeping(h, &sleeping)))
		PH_THROW(error);
	return sleeping;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_setSleeping(JNIEnv * env, jobject obj, jboolean sleeping) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_setSleeping(h, (int)sleeping)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_LCDBase_getWidth(JNIEnv * env, jobject obj) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int width;
	if ((error = PhidgetLCD_getWidth(h, &width)))
		PH_THROW(error);
	return width;
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeBitmap__IIII_3BLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jint xpos, jint ypos, jint xsize, jint ysize, jbyteArray bitmap, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_writeBitmap_async(h, (int)xpos, (int)ypos, (int)xsize, (int)ysize, bitmapArr, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeBitmap__IIII_3B(JNIEnv * env, jobject obj, jint xpos, jint ypos, jint xsize, jint ysize, jbyteArray bitmap) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint8_t *bitmapArr = (*env)->GetByteArrayElements(env, bitmap, 0);
	if ((error = PhidgetLCD_writeBitmap(h, (int)xpos, (int)ypos, (int)xsize, (int)ysize, bitmapArr)))
		PH_THROW(error);
	(*env)->ReleaseByteArrayElements(env, bitmap, bitmapArr, 0);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeText__Lcom_phidget22_LCDFont_2IILjava_lang_String_2(JNIEnv * env, jobject obj, jobject font, jint xpos, jint ypos, jstring text) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetLCD_writeText(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (int)xpos, (int)ypos, (const char *)(text == NULL ? NULL : (*env)->GetStringUTFChars(env, text, NULL)))))
		PH_THROW(error);
}

JNIEXPORT void JNICALL Java_com_phidget22_LCDBase_writeText__Lcom_phidget22_LCDFont_2IILjava_lang_String_2Lcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jobject font, jint xpos, jint ypos, jstring text, jobject asyncHandler) {
	PhidgetLCDHandle h = (PhidgetLCDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetLCD_writeText_async(h, (PhidgetLCD_Font)(*env)->CallIntMethod(env, font, LCDFont_getCode_mid), (int)xpos, (int)ypos, (const char *)(text == NULL ? NULL : (*env)->GetStringUTFChars(env, text, NULL)), asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}
