/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_PressureSensor.h"
#include "com_phidget22_PressureSensorBase.h"

jclass pressureSensor_class;
extern jfieldID phidget_handle_fid;
jmethodID pressureSensor_cons;

static jclass pressureChangeEvent_class;
static jmethodID firePressureChange_mid	;
static jmethodID pressureChangeEvent_cons;
static jfieldID nativePressureChangeHandler_fid;

void com_phidget22_PressureSensorBase_OnLoad(JNIEnv *env) {
	if (!(pressureSensor_class = (*env)->FindClass(env, "com/phidget22/PressureSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PressureSensorBase");
	if (!(pressureSensor_class = (jclass)(*env)->NewGlobalRef(env, pressureSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef pressureSensor_class");
	if (!(pressureSensor_cons = (*env)->GetMethodID(env, pressureSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from pressureSensor_class");

	if (!(pressureChangeEvent_class = (*env)->FindClass(env, "com/phidget22/PressureSensorPressureChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PressureSensorPressureChangeEvent");
	if (!(pressureChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, pressureChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PressureChangeEvent_class");
	if (!(firePressureChange_mid = (*env)->GetMethodID(env, pressureSensor_class, "firePressureChange", "(Lcom/phidget22/PressureSensorPressureChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePressureChange");
	if (!(pressureChangeEvent_cons = (*env)->GetMethodID(env, pressureChangeEvent_class, "<init>", "(Lcom/phidget22/PressureSensor;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PressureChangeEvent_class");
	if (!(nativePressureChangeHandler_fid = (*env)->GetFieldID(env, pressureSensor_class, "nativePressureChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePressureChangeHandler from pressureSensor_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_PressureSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetPressureSensorHandle phid;
	int error; 
	if ((error = PhidgetPressureSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PressureSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetPressureSensor_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetPressureSensor_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_PressureSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetPressureSensor_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_PressureSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetPressureSensor_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getPressure(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double pressure;
	if ((error = PhidgetPressureSensor_getPressure(h, &pressure)))
		PH_THROW(error);
	return pressure;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMinPressure(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minPressure;
	if ((error = PhidgetPressureSensor_getMinPressure(h, &minPressure)))
		PH_THROW(error);
	return minPressure;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMaxPressure(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxPressure;
	if ((error = PhidgetPressureSensor_getMaxPressure(h, &maxPressure)))
		PH_THROW(error);
	return maxPressure;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getPressureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double pressureChangeTrigger;
	if ((error = PhidgetPressureSensor_getPressureChangeTrigger(h, &pressureChangeTrigger)))
		PH_THROW(error);
	return pressureChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_setPressureChangeTrigger(JNIEnv * env, jobject obj, jdouble pressureChangeTrigger) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetPressureSensor_setPressureChangeTrigger(h, (double)pressureChangeTrigger)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMinPressureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minPressureChangeTrigger;
	if ((error = PhidgetPressureSensor_getMinPressureChangeTrigger(h, &minPressureChangeTrigger)))
		PH_THROW(error);
	return minPressureChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_PressureSensorBase_getMaxPressureChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxPressureChangeTrigger;
	if ((error = PhidgetPressureSensor_getMaxPressureChangeTrigger(h, &maxPressureChangeTrigger)))
		PH_THROW(error);
	return maxPressureChangeTrigger;
}

static void CCONV pressureChange_handler(PhidgetPressureSensorHandle h, void *arg, double pressure) {
	jobject pressureChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((pressureChangeEv = (*env)->NewObject(env, pressureChangeEvent_class, pressureChangeEvent_cons, obj, pressure)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePressureChange_mid, pressureChangeEv);
		(*env)->DeleteLocalRef(env, pressureChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_PressureSensorBase_enablePressureChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePressureChangeHandler_fid, b);
	PhidgetPressureSensorHandle h = (PhidgetPressureSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetPressureSensor_setOnPressureChangeHandler(h, b ? pressureChange_handler : NULL, (void *)(uintptr_t) gr);
}
