/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_Stepper.h"
#include "com_phidget22_StepperBase.h"

jclass stepper_class;
extern jfieldID phidget_handle_fid;
jmethodID stepper_cons;

static jclass positionChangeEvent_class;
static jmethodID firePositionChange_mid	;
static jmethodID positionChangeEvent_cons;
static jfieldID nativePositionChangeHandler_fid;

static jclass velocityChangeEvent_class;
static jmethodID fireVelocityChange_mid	;
static jmethodID velocityChangeEvent_cons;
static jfieldID nativeVelocityChangeHandler_fid;

static jclass stoppedEvent_class;
static jmethodID fireStopped_mid	;
static jmethodID stoppedEvent_cons;
static jfieldID nativeStoppedHandler_fid;

void com_phidget22_StepperBase_OnLoad(JNIEnv *env) {
	if (!(stepper_class = (*env)->FindClass(env, "com/phidget22/StepperBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/StepperBase");
	if (!(stepper_class = (jclass)(*env)->NewGlobalRef(env, stepper_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef stepper_class");
	if (!(stepper_cons = (*env)->GetMethodID(env, stepper_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from stepper_class");

	if (!(positionChangeEvent_class = (*env)->FindClass(env, "com/phidget22/StepperPositionChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/StepperPositionChangeEvent");
	if (!(positionChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, positionChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref PositionChangeEvent_class");
	if (!(firePositionChange_mid = (*env)->GetMethodID(env, stepper_class, "firePositionChange", "(Lcom/phidget22/StepperPositionChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID firePositionChange");
	if (!(positionChangeEvent_cons = (*env)->GetMethodID(env, positionChangeEvent_class, "<init>", "(Lcom/phidget22/Stepper;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from PositionChangeEvent_class");
	if (!(nativePositionChangeHandler_fid = (*env)->GetFieldID(env, stepper_class, "nativePositionChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativePositionChangeHandler from stepper_class");

	if (!(velocityChangeEvent_class = (*env)->FindClass(env, "com/phidget22/StepperVelocityChangeEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/StepperVelocityChangeEvent");
	if (!(velocityChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, velocityChangeEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref VelocityChangeEvent_class");
	if (!(fireVelocityChange_mid = (*env)->GetMethodID(env, stepper_class, "fireVelocityChange", "(Lcom/phidget22/StepperVelocityChangeEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireVelocityChange");
	if (!(velocityChangeEvent_cons = (*env)->GetMethodID(env, velocityChangeEvent_class, "<init>", "(Lcom/phidget22/Stepper;D)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from VelocityChangeEvent_class");
	if (!(nativeVelocityChangeHandler_fid = (*env)->GetFieldID(env, stepper_class, "nativeVelocityChangeHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeVelocityChangeHandler from stepper_class");

	if (!(stoppedEvent_class = (*env)->FindClass(env, "com/phidget22/StepperStoppedEvent")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/StepperStoppedEvent");
	if (!(stoppedEvent_class = (jclass)(*env)->NewGlobalRef(env, stoppedEvent_class)))
		JNI_ABORT_STDERR("Couldn't create global ref StoppedEvent_class");
	if (!(fireStopped_mid = (*env)->GetMethodID(env, stepper_class, "fireStopped", "(Lcom/phidget22/StepperStoppedEvent;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID fireStopped");
	if (!(stoppedEvent_cons = (*env)->GetMethodID(env, stoppedEvent_class, "<init>", "(Lcom/phidget22/Stepper;)V")))
		JNI_ABORT_STDERR("Couldn't get method ID <init> from StoppedEvent_class");
	if (!(nativeStoppedHandler_fid = (*env)->GetFieldID(env, stepper_class, "nativeStoppedHandler", "J")))
		JNI_ABORT_STDERR("Couldn't get Field ID nativeStoppedHandler from stepper_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_StepperBase_create(JNIEnv * env, jclass obj) {
	PhidgetStepperHandle phid;
	int error; 
	if ((error = PhidgetStepper_create(&phid)) != EPHIDGET_OK) {
		PH_THROW(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getAcceleration(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double acceleration;
	if ((error = PhidgetStepper_getAcceleration(h, &acceleration)))
		PH_THROW(error);
	return acceleration;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setAcceleration(JNIEnv * env, jobject obj, jdouble acceleration) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setAcceleration(h, (double)acceleration)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMinAcceleration(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minAcceleration;
	if ((error = PhidgetStepper_getMinAcceleration(h, &minAcceleration)))
		PH_THROW(error);
	return minAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMaxAcceleration(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxAcceleration;
	if ((error = PhidgetStepper_getMaxAcceleration(h, &maxAcceleration)))
		PH_THROW(error);
	return maxAcceleration;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_StepperBase_getControlMode(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	PhidgetStepper_ControlMode controlMode;
	if ((error = PhidgetStepper_getControlMode(h, &controlMode)))
		PH_THROW(error);
	return (*env)->CallStaticObjectMethod(env, StepperControlMode_class, StepperControlMode_getEnum_mid, controlMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setControlMode(JNIEnv * env, jobject obj, jobject controlMode) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setControlMode(h, (PhidgetStepper_ControlMode)(*env)->CallIntMethod(env, controlMode, StepperControlMode_getCode_mid))))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double currentLimit;
	if ((error = PhidgetStepper_getCurrentLimit(h, &currentLimit)))
		PH_THROW(error);
	return currentLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setCurrentLimit(JNIEnv * env, jobject obj, jdouble currentLimit) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setCurrentLimit(h, (double)currentLimit)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMinCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minCurrentLimit;
	if ((error = PhidgetStepper_getMinCurrentLimit(h, &minCurrentLimit)))
		PH_THROW(error);
	return minCurrentLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMaxCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxCurrentLimit;
	if ((error = PhidgetStepper_getMaxCurrentLimit(h, &maxCurrentLimit)))
		PH_THROW(error);
	return maxCurrentLimit;
}

JNIEXPORT jint JNICALL Java_com_phidget22_StepperBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t dataInterval;
	if ((error = PhidgetStepper_getDataInterval(h, &dataInterval)))
		PH_THROW(error);
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setDataInterval(h, (uint32_t)dataInterval)))
		PH_THROW(error);
}

JNIEXPORT jint JNICALL Java_com_phidget22_StepperBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t minDataInterval;
	if ((error = PhidgetStepper_getMinDataInterval(h, &minDataInterval)))
		PH_THROW(error);
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_StepperBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	uint32_t maxDataInterval;
	if ((error = PhidgetStepper_getMaxDataInterval(h, &maxDataInterval)))
		PH_THROW(error);
	return maxDataInterval;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_StepperBase_getEngaged(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int engaged;
	if ((error = PhidgetStepper_getEngaged(h, &engaged)))
		PH_THROW(error);
	return engaged;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setEngaged(JNIEnv * env, jobject obj, jboolean engaged) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setEngaged(h, (int)engaged)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getHoldingCurrentLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double holdingCurrentLimit;
	if ((error = PhidgetStepper_getHoldingCurrentLimit(h, &holdingCurrentLimit)))
		PH_THROW(error);
	return holdingCurrentLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setHoldingCurrentLimit(JNIEnv * env, jobject obj, jdouble holdingCurrentLimit) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setHoldingCurrentLimit(h, (double)holdingCurrentLimit)))
		PH_THROW(error);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_StepperBase_getIsMoving(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	int isMoving;
	if ((error = PhidgetStepper_getIsMoving(h, &isMoving)))
		PH_THROW(error);
	return isMoving;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getPosition(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double position;
	if ((error = PhidgetStepper_getPosition(h, &position)))
		PH_THROW(error);
	return position;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMinPosition(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minPosition;
	if ((error = PhidgetStepper_getMinPosition(h, &minPosition)))
		PH_THROW(error);
	return minPosition;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMaxPosition(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxPosition;
	if ((error = PhidgetStepper_getMaxPosition(h, &maxPosition)))
		PH_THROW(error);
	return maxPosition;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_addPositionOffset(JNIEnv * env, jobject obj, jdouble positionOffset) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_addPositionOffset(h, (double)positionOffset)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getRescaleFactor(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double rescaleFactor;
	if ((error = PhidgetStepper_getRescaleFactor(h, &rescaleFactor)))
		PH_THROW(error);
	return rescaleFactor;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setRescaleFactor(JNIEnv * env, jobject obj, jdouble rescaleFactor) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setRescaleFactor(h, (double)rescaleFactor)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getTargetPosition(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double targetPosition;
	if ((error = PhidgetStepper_getTargetPosition(h, &targetPosition)))
		PH_THROW(error);
	return targetPosition;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setTargetPosition__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble targetPosition, jobject asyncHandler) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, (*env)->NewGlobalRef(env, obj));
	(*env)->SetObjectArrayElement(env, arr, 1, (*env)->NewGlobalRef(env, asyncHandler));
	PhidgetStepper_setTargetPosition_async(h, (double)targetPosition, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setTargetPosition__D(JNIEnv * env, jobject obj, jdouble targetPosition) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setTargetPosition(h, (double)targetPosition)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getVelocity(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double velocity;
	if ((error = PhidgetStepper_getVelocity(h, &velocity)))
		PH_THROW(error);
	return velocity;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double velocityLimit;
	if ((error = PhidgetStepper_getVelocityLimit(h, &velocityLimit)))
		PH_THROW(error);
	return velocityLimit;
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_setVelocityLimit(JNIEnv * env, jobject obj, jdouble velocityLimit) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	if ((error = PhidgetStepper_setVelocityLimit(h, (double)velocityLimit)))
		PH_THROW(error);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMinVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double minVelocityLimit;
	if ((error = PhidgetStepper_getMinVelocityLimit(h, &minVelocityLimit)))
		PH_THROW(error);
	return minVelocityLimit;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_StepperBase_getMaxVelocityLimit(JNIEnv * env, jobject obj) {
	PhidgetStepperHandle h = (PhidgetStepperHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	double maxVelocityLimit;
	if ((error = PhidgetStepper_getMaxVelocityLimit(h, &maxVelocityLimit)))
		PH_THROW(error);
	return maxVelocityLimit;
}

static void CCONV positionChange_handler(PhidgetStepperHandle h, void *arg, double position) {
	jobject positionChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((positionChangeEv = (*env)->NewObject(env, positionChangeEvent_class, positionChangeEvent_cons, obj, position)) != 0) {
		(*env)->CallVoidMethod(env, obj, firePositionChange_mid, positionChangeEv);
		(*env)->DeleteLocalRef(env, positionChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_enablePositionChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativePositionChangeHandler_fid, b);
	PhidgetStepperHandle h = (PhidgetStepperHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetStepper_setOnPositionChangeHandler(h, b ? positionChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV stopped_handler(PhidgetStepperHandle h, void *arg) {
	jobject stoppedEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((stoppedEv = (*env)->NewObject(env, stoppedEvent_class, stoppedEvent_cons, obj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireStopped_mid, stoppedEv);
		(*env)->DeleteLocalRef(env, stoppedEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_enableStoppedEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeStoppedHandler_fid, b);
	PhidgetStepperHandle h = (PhidgetStepperHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetStepper_setOnStoppedHandler(h, b ? stopped_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV velocityChange_handler(PhidgetStepperHandle h, void *arg, double velocity) {
	jobject velocityChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((velocityChangeEv = (*env)->NewObject(env, velocityChangeEvent_class, velocityChangeEvent_cons, obj, velocity)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireVelocityChange_mid, velocityChangeEv);
		(*env)->DeleteLocalRef(env, velocityChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_StepperBase_enableVelocityChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	jlong gr = updateGlobalRef(env, obj, nativeVelocityChangeHandler_fid, b);
	PhidgetStepperHandle h = (PhidgetStepperHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetStepper_setOnVelocityChangeHandler(h, b ? velocityChange_handler : NULL, (void *)(uintptr_t) gr);
}
